int good_file_format(FILE *in_fp, char *id_string, char *filename);
void make_new_path(char *new_path, char *path, char *extension);
void strip_off_extension(char *filename, char *new);
void basefilename(char *filename, char *pathstring);

FILE *fopen_with_check(char *file_name, char *mode_string);
FILE *fopen_silently(char *file_name, char *mode_string);
FILE *fopen_or_exit(char *file_name, char *mode_string);
int open_rdonly_with_check(char *filename);
FILE *fopen_out_file(char *path, char *extension);
int open_new_file(char *filename);

void write_fe_header(FILE* fp, struct signature *sig_ptr);
void write_fe_data(FILE *out_fp, struct signature *s_ptr);
void write_fe_frame_number(FILE *out_fp, int frame);
void write_fe_bin(FILE *out_fp, float value);
void write_fe_energy(FILE *out_fp, float value);
int read_fe_into_sig(FILE *fp, struct signature *tptr);

void write_la_file_header(FILE *out_fp, char *input_info_string, int input_length);

void write_la_entry(FILE *out_fp, char *label, int start, int end);
FILE *la_open_file_check_header(char *sister_filename, int silentp);
int read_la_file(char *filename, int *nlabels_ptr, struct whyp labels[], int silentp);
int read_la_file_from_dir(char *dirname, char *filename, int *nlabels, 
			  struct whyp labels[], int silentp);

int read_wh_file(char *filename, int *nwh_ptr, struct whyp hyps[MAX_NTEMPLATES]);
void write_wh_file_hdr(FILE *file_ptr, char *input_info_string, int input_length);
void write_wh_file_line(FILE *file_ptr, char *string, int length, int start,
			float score);

int read_cv_file(char *dirname, char *filename, struct concept cvec[], char *extension, 
		 int new_namep);

void clip_word_name(char *output, char *raw_label);

void verify_is_directory(char *dir);
int file_exists(char *file);
